/* these define the offsets to the Pane data stored in the window structure */
#define GWL_PANE_LPMV		0
#define GWL_PANE_TYPE		1*sizeof(long)
#define GWL_PANE_PARENT		2*sizeof(long)
#define GWL_PANE_CALLBACK	3*sizeof(long)
#define GWL_PANE_FLAGS		4*sizeof(long)
#define EXTRA_PANE_SIZE		5*sizeof(long)

/* and MACROS for getting and setting the data from the window */
#define GetPaneMV(hWnd) (LPMV)GetWindowLong(hWnd, GWL_PANE_LPMV)
#define GetPaneType(hWnd) (int)GetWindowLong(hWnd, GWL_PANE_TYPE)
#define GetPaneParent(hWnd) (HWND)GetWindowLong(hWnd, GWL_PANE_PARENT)
#define GetPaneCallback(hWnd) (PANEHOTPROC)GetWindowLong(hWnd, GWL_PANE_CALLBACK)
#define GetPaneFlags(hWnd) (int)GetWindowLong(hWnd, GWL_PANE_FLAGS)

#ifdef WIN32
#define GetPaneInstance(hWnd) (HINSTANCE)GetWindowLong(hwndMVGetWindow(hWnd), GWL_HINSTANCE)
#define _export
#else
#define GetPaneInstance(hWnd) (HINSTANCE)GetWindowWord(hwndMVGetWindow(hWnd), GWW_HINSTANCE)
typedef int INT;
typedef int far * LPINT;
#endif // WIN32

#define SetPaneMV(hWnd, lpMV) SetWindowLong(hWnd, GWL_PANE_LPMV, (long)lpMV)
#define SetPaneType(hWnd, type) SetWindowLong(hWnd, GWL_PANE_TYPE, (long)type)
#define SetPaneParent(hWnd, hParent) SetWindowLong(hWnd, GWL_PANE_PARENT, (long)hParent)
#define SetPaneCallback(hWnd, fpP) SetWindowLong(hWnd, GWL_PANE_CALLBACK, (long)fpP)
#define SetPaneFlags(hWnd, flags) SetWindowLong(hWnd, GWL_PANE_FLAGS, (long)flags)

/* pane type ... the first 2 correspond to the subTopic identifiers */
#define NSR_PANE		0
#define SR_PANE		1
#define POPUP_PANE	2001

/* Pane flags */
#define P_NOHITS	1	/* supress search highlights? */ 
#define P_NOSIZE		2	/* skip processing of WM_SIZE? */
#define P_NOSELECT	4	/* supress text selection? */

/* Hotspot callback interface */
typedef  int (CALLBACK * PANEHOTPROC)(LPMV lpMV, LPMVHOTINFO lpHI);

/* Messages to/from the window class */
#define UWM_PANE_FOCUS	(WM_USER + 2000)

/* misc. typedefs */
typedef VA * LPVA;
typedef HTITLE * LPHTITLE;

/* PANE Window class */
#define MVPANECLASS "MV13PaneClass"
